<?php

class CaptadorController extends Controller
{
	
	public $layout='//layouts/column2';

	
	public function filters()
	{
		return array(
			'accessControl', // perform access control for CRUD operations
			'postOnly + delete', // we only allow deletion via POST request
		);
	}


	public function accessRules()
	{
		return array(
			array('allow',  
				'actions'=>array('index','create','update','delete'),
				'expression' => array('CaptadorController', 'validaracceso'),
			),
			array('deny',
				'users'=>array('*'),
			),
		);
	}

	public static function validaracceso() {
            if (!Yii::app()->user->isGuest) {
                   return true;
            } else {
                Yii::app()->user->setFlash('error', Yii::app()->params['sesion']);
                return false;
            }
        }
        
        
	public function actionView($id)
	{
		$this->render('view',array(
			'model'=>$this->loadModel($id),
		));
	}


	
	public function actionCreate()
	{
		$model=new Captador();
                $model->scenario = 'create'; 
                $this->pageTitle = 'AGREGAR CAPTADOR';

                $this->performAjaxValidation($model);
                
		if(isset($_POST['Captador']))
		{
			$model->attributes=$_POST['Captador'];
			try
                        {
                          $agregar= Captador::add();  
                          if ($agregar) {
                            Yii::app()->user->setFlash('success', '¡La captador se ha guardado exitosamente!');
                            $this->redirect(array('index'));  
                            }  else {
                               Yii::app()->user->setFlash('info', 'Error al agregar la captador.');
                            }
                        }catch(Exception $e)
                        {
                         Yii::app()->user->setFlash('danger', Yii::app()->params['error']); 
                        }
		}

		$this->render('create',array(
			'model'=>$model,
		));
	}


	public function actionUpdate($id)
	{
		$model=$this->loadModel($id);
                $model->scenario = 'update'; 
                $this->pageTitle = 'MODIFICAR CAPTADOR';
                
                
                
                $this->performAjaxValidation($model);
                
		if(isset($_POST['Captador']))
		{
         
			$model->attributes=$_POST['Captador'];
                      try
                        {
                          $editar=Captador::edit($id);  
                            Yii::app()->user->setFlash('success', 'La captador fue actualizado con éxito.');   
                            $this->redirect(Yii::app()->request->baseUrl."/captador");

                        }catch(Exception $e)
                        {
                         Yii::app()->user->setFlash('danger', Yii::app()->params['error']); 
                        }
		}

		$this->render('update',array(
			'model'=>$model,
		));
	}


	public function actionIndex()
	{
		$this->pageTitle = 'LISTA DE CAPTADORS';
		$model=new Captador('search');
		$model->unsetAttributes(); 
                if (isset($_GET['pageSize'])){
                    Yii::app()->user->setState('pageSize', (int) $_GET['pageSize']);
                    unset($_GET['pageSize']);
                }
		if(isset($_GET['Captador']))
			$model->attributes=$_GET['Captador'];

		$this->render('index',array(
			'model'=>$model,
		));
	}

public function actionDelete($id)
	{
		$model= new Captador();
                $model->borrar($id);
		if(!isset($_GET['ajax']))
			$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('index'));
	}
	
	public function loadModel($id)
	{
		$model=Captador::model()->findByPk($id);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}

	protected function performAjaxValidation($model)
	{
		if(isset($_POST['ajax']) && $_POST['ajax']==='captador-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}
	}
}
